#ifndef EMUCONFIG_H
#define EMUCONFIG_H

#ifndef EMUSYS_VALUE
#define EMUSYS_VALUE
#define CPS1	0
#define CPS2	1
#define MVS		2
#endif

#if defined(BUILD_CPS1PSP)

#define PBPNAME_STR			"CPS1PSP"
#define APPNAME_STR			"CAPCOM CPS1 Emulator for PSP"
#define VERSION_STR			"1.01"

#define VERSION_MAJOR		1
#define VERSION_MINOR		0
#define VERSION_BUILD		0

#define EMU_SYSTEM			CPS1
#define USE_CACHE			0
#define EEPROM_SIZE			128
#define GULIST_SIZE			40*1024		// CPS1 - 40KB

#define machine_main		cps1_main

#elif defined(BUILD_CPS2PSP)

#define PBPNAME_STR			"CPS2PSP"
#define APPNAME_STR			"CAPCOM CPS2 Emulator for PSP"
#define VERSION_STR			"1.02"

#define VERSION_MAJOR		1
#define VERSION_MINOR		0
#define VERSION_BUILD		0

#define EMU_SYSTEM			CPS2
#define USE_CACHE			1
#define EEPROM_SIZE			128
#define GULIST_SIZE			40*1024		// CPS2 - 40KB

#define machine_main		cps2_main

#elif defined(BUILD_MVSPSP)

#define PBPNAME_STR			"MVSPSP"
#define APPNAME_STR			"NEOGEO Emulator for PSP"
#define VERSION_STR			"1.0"

#define VERSION_MAJOR		1
#define VERSION_MINOR		0
#define VERSION_BUILD		0

#define EMU_SYSTEM			MVS
#define USE_CACHE			1
#define GULIST_SIZE			96*1024		// MVS - 96KB

#define machine_main		neogeo_main

#endif

#endif /* EMUCONFIG_H */
